Apple II
File Type Notes
_____________________________________________________________________________
                                                  Developer Technical Support


About Apple II File Type Notes                                     March 1989
_____________________________________________________________________________

This Note accompanies each release of Apple II File Type Notes.  This release 
includes information on file formats for file types $D8 and $E0, as well as an 
updated list of all currently assigned Apple II file types and auxiliary 
types.

Developer Technical Support requires four things from a developer before 
publishing a file format for your application in a File Type Note:

1.    The file format itself, preferably in an ASCII text file.
2.    Assurances that the product is shipping.  We don't want to jump 
      the gun by releasing a Note for an unannounced product or a 
      product which is unavailable.  The enclosed list of file type 
      assignments includes only those products which we know are 
      currently shipping.
Note: If your product is shipping, but your file type is not
      listed, you need to let us know since engineering uses this list
      to identify files in future Apple products, such as future
      releases of the Apple IIGS Finder.  If this Note does not list
      your file type and auxiliary type assignments, engineering will
      not be able to include them in future products.  The "short" names
      listed in this Note will be used as the descriptors for such files,
      so you should contact DTS if a descriptor for one of your files is
      unsuitable.
3.    Written permission to publish the file format.  We don't want you 
      to submit the format and then be surprised when we publish it.
4.    Your company name and address, so we can refer readers to you for 
      more information about your product.

We welcome your file formats, suggestions on existing Notes, and your requests 
for file type or auxiliary type assignments.  Please contact us at:

                    Apple II File Type Notes
                    Developer Technical Support
                    Apple Computer, Inc.
                    20525 Mariani Avenue, M/S 51-T
                    Cupertino, CA  95014
                    AppleLink: AIIDTS
                    MCI Mail:  AIIDTS (264-0103)

The universal sharing of file formats opens new dimensions to personal 
computing, so we want Apple II File Type Notes distributed as widely as 
possible.  We send them to all Partners and Associates at no charge, and we 
also post them on AppleLink in the Developer Services bulletin board and other 
electronic sources.  You can also order them through APDA.  As an APDA 
customer, you have access to the tools and documentation necessary to develop 
Apple-compatible products.  For more information about APDA, contact:

                    APDA
                    Apple Computer, Inc.
                    20525 Mariani Avenue, M/S 33-G
                    Cupertino, CA 95014
                    (800) 282-APDA or (800) 282-2732
                    Fax:  (408) 562-3971
                    Telex:  171-576
                    AppleLink:  APDA

We place no restrictions on copying the Notes, with the exception that you 
cannot resell them.  You should note, however, that some of the file formats 
are the copyrighted property of the companies which own them.  These formats 
are identified in the appropriate Notes, and you should treat them with 
respect to the applicable copyright laws.

Following is a current list of all file type and auxiliary type assignments.  
Assignments with a date indicate the release date of the File Type Note for 
that assignment, and all file types and auxiliary types which are not listed 
in this Note are reserved and should not be used.


Definitions

The following definitions apply to all Apple II File Type Notes and will not 
be repeated in each Note:

Boolean        A binary indicator.  If the most significant bit of a 
               boolean is set, the boolean is TRUE.  If it is clear, it is 
               FALSE.
Byte           An 8-bit value.
Double Long    A 64-bit value, composed of eight byte, four words or two 
               long words.  The most significant byte is stored last.
Fixed          A four-byte signed value where the least significant word 
               represents a fractional part and the most significant word 
               represents an integer part (i.e., the value 32767.0 would be 
               stored as $00 $00 $FF $7F to represent the integer part of 
               $7FFF (+32767) and the fractional part of $0000 (0)).  The 
               value 4.5 would be stored as $00 $80 $04 $00 to represent 
               the integer part of $0004 and the fractional part of $8000.  
               The value $8000 is represented as 1000000000000000 in 
               binary.  The bit immediately following the decimal point is 
               set, which indicates the value of 2^-1, or one-half.  The 
               full binary expansion of 4.5 is 
               0000000000000100.1000000000000000, which indicates 2^2 + 2^-
               1 or 4 + 0.5, which is 4.5.  The Apple IIGS Integer Math 
               Tools contain routines to assist with Fixed arithmetic.
Flag unit      Any storage unit (byte, word, long) treated as a series of 
               flag bits rather than as a numeric value.
Long           A 32-bit value, composed of four bytes or two words.  The 
               most significant byte is stored last.  For example, 
               $00E102A8 would be stored as $A8 $02 $E1 $00.
Reverse        The 65xxx series microprocessors normally store values with 
               the least significant byte (LSB) first, while other 
               microprocessors may store values with the most significant 
               byte (MSB) first.  The designation Reverse (Rev.) indicates 
               that values must be rearranged before using them  (i.e., a 
               Long value of $11223344 would be stored as $44 $33 $22 $11, 
               but a Reverse Long value would be stored as $11 $22 $33 
               $44).
String         A Pascal-type string.  It consists of a length byte followed 
               by up to 255 bytes of ASCII data.
Word           A 16-bit value, composed of two bytes.  The most significant 
               byte of the word is stored after the least significant byte.  
               For example, $02FF would be stored $FF $02.

All bit definitions are given as bit numbers.  Bit 0 is always the least 
significant bit.  The most significant bit of a byte is bit 7; the most 
significant bit of a word is bit 15, etc.

_____________________________________________________________________________

File Type Assignments                                              March 1989

                                                                      New ***
                                                                  Revised *R*
File Aux.
Type Type   File Type Description            Auxiliary Type Description  Date
_____________________________________________________________________________
$00         Typeless File
$01         Bad Blocks File
$02         Apple /// Pascal Code 
$03         Apple /// Pascal Text
$04         ASCII Text                       Random-access record-length
$05         Apple /// Pascal Data 
$06         Binary                           Load address in bank 0
$07         Apple /// Font 
$08         Apple II or /// Graphics                                   11/88
$08  $4000  Packed Hi-Res Image              Image Format              11/88
$08  $4001  Packed Double Hi-Res Image       Image Format              11/88
$09         Apple /// BASIC Program 
$0A         Apple /// BASIC Data 
$0B         Apple /// Word Processor File
$0C         Apple /// SOS File
$0F         Directory File (Folder)
$10         Apple /// RPS Data 
$11         Apple /// RPS Index 
$12         Apple /// AppleFile Discard 
$13         Apple /// AppleFile Model 
$14         Apple /// AppleFile Report Format 
$15         Apple /// Screen Library 
$16         PFS Document
$16  $0001  PFS:File Document                Program Specific
$16  $0002  PFS:Write Document               Program Specific
$16  $0003  PFS:Graph Document               Program Specific
$16  $0004  PFS:Plan Document                Program Specific
$16  $0016  PFS Internal Data                Program Specific
$19         AppleWorks Data Base File        Upper-/lowercase in name   11/88
$1A         AppleWorks Word Processor File   Upper-/lowercase in name   11/88
$1B         AppleWorks Spreadsheet File      Upper-/lowercase in name   11/88
$20         The Desktop Manager File
$29         SOS Dictionary File
$2A         Apple II Source Code File        Application Specific
$2B         Apple II Object Code File        Application Specific
$2C         Apple II Interpreted Code File   Application Specific
$2D         Apple II Programming Language Data File    Application Specific
$50         Apple IIGS Word Processor File
$50  $8001  DeluxeWrite Document             Application Specific
$50  $8010  AppleWorks GS Word Processor     Application Specific
$51         Apple IIGS Spreadsheet File
$51  $8010  AppleWorks GS Spreadsheet        Application Specific
$52         Apple IIGS Data Base File
$52  $8010  AppleWorks GS Data Base          Application Specific
$52  $8011  AppleWorks GS DB Template        Application Specific
$53         Drawing File
$53  $8010  AppleWorks GS Graphics           Application Specific
$54         Apple IIGS Desktop Publishing File
$54  $8010  AppleWorks GS Page Layout        Application Specific
$54  $DD3E  Medley Document File             Application Specific
$55         Hypermedia File                  Application Specific
$55  $8001  Tutor-Tech Hypermedia File       Application Specific
$56         Educational Data                 Application Specific
$56  $8001  Tutor-Tech Scores                Application Specific
$57         Stationery
$58         Help File
$59         Communications File              Application Specific
$59  $8010  AppleWorks GS Communications     Application Specific
$5A         Application Configuration File   Application Specific
$5A  $8010  AppleWorks GS General            Application Specific
$5B         Animation File                   Application Specific
$6B         PC Transporter BIOS
$6D         PC Transporter Driver
$6E         PC Transporter Pre-boot
$6F         PC Transporter Volume
$A0         WordPerfect Document             WordPerfect               01/89
$AB         Apple IIGS BASIC Program
$AC         Apple IIGS BASIC TDF
$AD         Apple IIGS BASIC Data 
$B0         Apple IIGS  Source File          APW Language type
$B1         Apple IIGS Object File
$B2         Apple IIGS Library File
$B3         ProDOS 16 or GS/OS Application
$B4         ProDOS 16 or GS/OS Run-Time Library 
$B5         ProDOS 16 or GS/OS Shell Application 
$B6         ProDOS 16 or GS/OS Permanent Init File  Not loaded if bit 15 set
$B7         ProDOS 16 or GS/OS Temporary Init File  Not loaded if bit 15 set
$B8         Apple IIGS New Desk Accessory           Not loaded if bit 15 set
$B9         Apple IIGS Classic Desk Accessory       Not loaded if bit 15 set
$BA         Apple IIGS Tool
$BB         Apple IIGS Device Driver                Not loaded if bit 15 set
$BC         Apple IIGS Generic Load File
$BD         GS/OS File System Translator            Not loaded if bit 15 set
$BF         ProDOS 16 or GS/OS Document File
$C0         Packed Super Hi-Res Picture      Application Specific
$C0  $0000  Paintworks Packed Picture        Application Specific      11/88
$C0  $0001  Packed Super Hi-Res Image        Application Specific      11/88
$C0  $0002  Apple Preferred Format Picture   Application Specific      11/88
$C0  $0003  Packed QuickDraw II PICT File    Application Specific      11/88
$C1         Super Hi-Res Picture             Application Specific      11/88
$C1  $0000  Super Hi-Res Screen Image        Application Specific      11/88
$C1  $0001  QuickDraw PICT File              Application Specific      11/88
$C2         Paintworks Animation
$C3         Paintworks Palette
$C5         Object-Oriented Graphics                    Application Specific
$C5  $8000  Draw Plus Document                          Application Specific
$C5  $C000  Architecture Design Document                Application Specific
$C5  $C001  Architecture Design Pre-drawn Object        Application Specific
$C5  $C002  Architecture Design Custom Object           Application Specific
$C5  $C003  Architecture Design Clipboard Object        Application Specific
$C8         Apple IIGS Font File
$C8  $0000  Font (Standard Apple IIGS QuickDraw II Font)    Reserved   01/89
$C9         Apple IIGS Finder Data File
$CA         Apple IIGS Finder Icon File
$D5         Music Sequence File                         Application Specific
$D5  $0000  Music Construction Set Music Sequence File  Application Specific
$D5  $8002  Diversi-Tune Sequence File                  Application Specific
$D6         Instrument File                             Application Specific
$D6  $0000  Music Construction Set Instrument File      Application Specific
$D6  $8002  Diversi-Tune Instrument File                Application Specific
$D7         MIDI File
$D7  $0000  Standard MIDI File                          Application Specific
$D8         Sampled Sound File                          Application Specific
$D8  $0000  Audio Interchange File Format (AIFF)        Appl. Spec. ***03/89
$D8  $0001  Compressed Sample Sound (ACE) File
$D8  $0002  Apple IIGS Sampled Instrument Format (ASIF) Appl. Spec. ***03/89
$E0         ALU Telecom Library File         Carolina System Software
$E0  $0001  AppleSingle File                 Application Specific   ***03/89
$E0  $0002  AppleDouble Header File          Application Specific   ***03/89
$E0  $0003  AppleDouble Data File            Application Specific   ***03/89
$E0  $8001  ACU Compressed Data File         Application Specific
$E2         AppleTalk File
$EF         Pascal area on partitioned disk
$F0         BASIC Command File
$F1         User-Defined File Type #1
$F2         User-Defined File Type #2
$F3         User-Defined File Type #3
$F4         User-Defined File Type #4
$F5         User-Defined File Type #5
$F6         User-Defined File Type #6
$F7         User-Defined File Type #7
$F8         User-Defined File Type #8
$F9         Operating System File
$FA         Integer BASIC Program 
$FB         Integer BASIC Variables
$FC         AppleSoft BASIC Program 
$FD         AppleSoft BASIC Variables
$FE         Relocatable Code
$FF         ProDOS 8 Application
_____________________________________________________________________________
